// Use Foreach
import { foreach, json } from "../kit";

// Export
export default (Vuex, modules, utils, getters, global) => {
  // Loop Modules
  foreach(modules, (module, key) => {
    // Bind Json as Scope
    module = module.bind(json);

    // Add Namespace
    module.namespaced = true;
  });

  // Merge Global
  if (global) {
    Object.assign(modules, global);
  }

  // Return
  return new Vuex.Store({
    modules,
    getters
  });
};
